package au.com.AidoP.SwiftHelp;

import java.util.HashMap;
import java.util.Map;

import net.milkbowl.vault.economy.Economy;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;

public final class SwiftHelp extends JavaPlugin {

	@SuppressWarnings("rawtypes")
	Map Hmap = new HashMap();
	public static Economy econ = null;

	public void onEnable(){
		if (!setupEconomy() ) {
			getLogger().severe(String.format("[%s] - Disabled due to no Vault dependency found!", getDescription().getName()));
			getServer().getPluginManager().disablePlugin(this);
			return;
		}
		else{
			getLogger().info(ChatColor.GREEN + "SwiftHelp at your service!");
		}
	}
	
	
	public void onDisable(){
		getLogger().info(ChatColor.RED + "Why do you have to leave so soon?!?");
	}

	private boolean setupEconomy() {
		if (getServer().getPluginManager().getPlugin("Vault") == null) {
			return false;
		}
		RegisteredServiceProvider<Economy> rsp = getServer().getServicesManager().getRegistration(Economy.class);
		if (rsp == null) {
			return false;
		}
		econ = rsp.getProvider();
		return econ != null;
	}

	
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args){
		if(sender instanceof Player){

			if(sender.hasPermission("tpt")){ // Teleport to a player.
				int i = 0;
				if(i <= 10){
					if(cmd.getName().equalsIgnoreCase("tpt") && args.length <= 10 && args.length >= 1){
						tptCMD(i, args, sender);
						return true;
					}
				}
				else if(cmd.getName().equalsIgnoreCase("tpt") && args.length == 0){
					sender.sendMessage(ChatColor.RED + "Please enter valid player!");
				}
			}


			else if(sender.hasPermission("tph")){ // Teleport a player to you.
				int i = 0;
				if(i <= 10){
					if(cmd.getName().equalsIgnoreCase("tph") && args.length <= 10 && args.length >= 1){
						tphCMD(i, args, sender);
						return true;
					}
					
					else if(cmd.getName().equalsIgnoreCase("tph") && args.length == 0){
						sender.sendMessage(ChatColor.RED + "Please enter valid player!");
					}
				}
			}

			else if(sender.hasPermission("spawn")){
				if(cmd.getName().equalsIgnoreCase("spawn")){
					spawnCMD(args, sender);
					return true;
				}
			}
			
			else if(sender.hasPermission("tpa")){
				if(cmd.getName().equalsIgnoreCase("tpa")){
					tpaCMD(sender);
					return true;
				}
			}

			if(cmd.getName().equalsIgnoreCase("open")){
				openCMD(sender, args);
				return true;
			}


			if(sender.hasPermission("sp")){
				if(cmd.getName().equalsIgnoreCase("sp") && args[0].equalsIgnoreCase("bed")){
					Location bedSpawn = ((Player) sender).getBedSpawnLocation();
					((Player) sender).teleport(bedSpawn);
					return true;
				}
				else if(cmd.getName().equalsIgnoreCase("sp") && args.length == 0){
					((Player) sender).teleport(((Player) sender).getWorld().getSpawnLocation());
					return true;
				}
			}

			if(sender.hasPermission("feed")){
				if(cmd.getName().equalsIgnoreCase("feed") && args.length >= 1){
					Player player = (Player) Bukkit.getServer().getPlayer(args[0]);
					player.setFoodLevel(20);
					return true;
				}
				else if(cmd.getName().equalsIgnoreCase("feed") && args.length == 0){
					Player player = (Player) sender;
					player.setFoodLevel(20);
					return true;
				}
			}

			if(sender.hasPermission("heal")){
				if(cmd.getName().equalsIgnoreCase("heal") && args.length >= 1){
					Player player = (Player) Bukkit.getServer().getPlayer(args[0]);
					player.setHealth(20);
					return true;
				}
				else if(cmd.getName().equalsIgnoreCase("heal") && args.length == 0){
					Player player = (Player) sender;
					player.setHealth(20);
					return true;
				}
			}

			if(sender.hasPermission("colour")){
				colourCMD(args, sender);
				return true;
			}

			if(sender.hasPermission("money.check")){
				if(cmd.getName().equalsIgnoreCase("money")){

				}
			}

			if(sender.hasPermission("money.pay")){
				if(cmd.getName().equalsIgnoreCase("pay") && args.length == 3){
					
				}
			}

			if(sender.hasPermission("money.take")){
				if(cmd.getName().equalsIgnoreCase("take")){

				}
			}
		}

		if(cmd.getName().equalsIgnoreCase("swifthelp")){
			sender.sendMessage(ChatColor.GREEN + "SwiftHelp V. 0.3.1!");
			sender.sendMessage(ChatColor.DARK_GREEN + "Commands:");
			sender.sendMessage(ChatColor.GREEN + "/spawn <animal/entity>");
			sender.sendMessage(ChatColor.GREEN + "/tpt <player>");
			sender.sendMessage(ChatColor.GREEN + "/tph <player>");
			sender.sendMessage(ChatColor.GREEN + "/tpa");
			sender.sendMessage(ChatColor.GREEN + "/sp [bed]");
			sender.sendMessage(ChatColor.GREEN + "/colour <colour> [text]");
			sender.sendMessage(ChatColor.GREEN + "/feed [player]");
			sender.sendMessage(ChatColor.GREEN + "/heal [player]");
			sender.sendMessage(ChatColor.GREEN + " ");
			sender.sendMessage(ChatColor.GREEN + "Key: <REQUIERD> [OPTIONAL]");
			return true;
		}
		return false;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	@SuppressWarnings({ "unchecked", "null" })
	public void tptCMD(int i, String[] args, CommandSender sender){
		Player player = (Player) sender;
		Player playert = (Bukkit.getServer().getPlayer(args[i]));

		if(playert == null){
			sender.sendMessage(ChatColor.RED + args[i] + " is not online or doese not exist!");
		}
		else{
			sender.sendMessage("asked " + args[i]);
			playert.sendMessage(sender + " Wants to telleport to you! Type /tpa to accept!");
			Hmap.put(playert.getDisplayName() + "TPT Player T", playert);
			Hmap.put(playert.getDisplayName() + "TPT Player", player);
			long time = System.nanoTime();
			if(time >= 50000){
				playert = null;
				Hmap.put(playert.getDisplayName(), playert);
				i++;
			}
		}
	}

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	@SuppressWarnings({ "unchecked", "null" })
	public void tphCMD(int i, String[] args, CommandSender sender){
		Player player = (Player) sender;
		Player playerh = (Bukkit.getServer().getPlayer(args[i]));

		if(playerh == null){
			sender.sendMessage(ChatColor.RED + args[i] + " is not online or doese not exist!");
		}
		else{
			sender.sendMessage(ChatColor.ITALIC + "asked " + args[i]);
			playerh.sendMessage(ChatColor.DARK_GREEN + "" + sender + " Wants to telleport you to him/her! Type /tpa to accept!");
			Hmap.put(playerh.getDisplayName() + "TPH Player H", playerh);
			Hmap.put(playerh.getDisplayName() + "TPH Player", player);
			long time = System.nanoTime();
			if(time >= 50000 ){
				playerh = null;
				Hmap.put(playerh.getDisplayName(), playerh);
				i++;
			}
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	@SuppressWarnings("unchecked")
	public void tpaCMD(CommandSender sender){
		Player playerh = (Player) Hmap.get(((Player) sender).getDisplayName() + "TPH Player H");
		Player playert = (Player) Hmap.get(((Player) sender).getDisplayName() + "TPT Player");
		Player playertt = (Player) Hmap.get(((Player) sender).getDisplayName() + "TPT Player T");
		Player player = (Player) Hmap.get(((Player) sender).getDisplayName() + "TPH Player");
		if(playerh != null){
			playerh.teleport(player);
			Hmap.put(((Player) sender).getDisplayName() + "", null);
		}
		else if(playert != null){
			playertt.teleport(playert);
			Hmap.put(((Player) sender).getDisplayName() + "TPT Player T", null);
			Hmap.put(((Player) sender).getDisplayName() + "TPT Player", null);
		}
		else{
			sender.sendMessage(ChatColor.RED + "Nobody asked for a teleport!");
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public void spawnCMD(String[] args, CommandSender sender){
		int entt = 0;
		if(args[0].equalsIgnoreCase("bat")) entt = 1;
		else if(args[0].equalsIgnoreCase("blaze")) entt = 2;
		else if(args[0].equalsIgnoreCase("cave") && args[1].equalsIgnoreCase("spider")) entt = 3;
		else if(args[0].equalsIgnoreCase("chicken")) entt = 4;
		else if(args[0].equalsIgnoreCase("cow")) entt = 5;
		else if(args[0].equalsIgnoreCase("creeper")) entt = 6;
		else if(args[0].equalsIgnoreCase("ender") && args[1].equalsIgnoreCase("dragon")) entt = 7;
		else if(args[0].equalsIgnoreCase("enderman")) entt = 8;
		else if(args[0].equalsIgnoreCase("ghast")) entt = 9;
		else if(args[0].equalsIgnoreCase("giant")) entt = 10;
		else if(args[0].equalsIgnoreCase("iron") && args[1].equalsIgnoreCase("golem")) entt = 11;
		else if(args[0].equalsIgnoreCase("magma") && args[1].equalsIgnoreCase("cube") || args[0].equalsIgnoreCase("lava") && args[1].equalsIgnoreCase("slime")) entt = 12;
		else if(args[0].equalsIgnoreCase("mooshroom") || args[0].equalsIgnoreCase("mushroom") && args[1].equalsIgnoreCase("cow")) entt = 13;
		else if(args[0].equalsIgnoreCase("ocelot") || args[0].equalsIgnoreCase("cat")) entt = 14;
		else if(args[0].equalsIgnoreCase("pig")) entt = 15;
		else if(args[0].equalsIgnoreCase("zombie") && args[1].equalsIgnoreCase("pigman")) entt = 16;
		else if(args[0].equalsIgnoreCase("sheep")) entt = 17;
		else if(args[0].equalsIgnoreCase("silverfish")) entt = 18;
		else if(args[0].equalsIgnoreCase("skelleton") || args[0].equalsIgnoreCase("skelly")) entt = 19;
		else if(args[0].equalsIgnoreCase("slime")) entt = 20;
		else if(args[0].equalsIgnoreCase("snowman") || args[0].equalsIgnoreCase("snow") && args[1].equalsIgnoreCase("golem")) entt = 21;
		else if(args[0].equalsIgnoreCase("spider")) entt = 22;
		else if(args[0].equalsIgnoreCase("squid")) entt = 23;
		else if(args[0].equalsIgnoreCase("villager")) entt = 24;
		else if(args[0].equalsIgnoreCase("witch")) entt = 25;
		else if(args[0].equalsIgnoreCase("wither")) entt = 26;
		else if(args[0].equalsIgnoreCase("wolf")) entt = 27;
		else if(args[0].equalsIgnoreCase("zombie")) entt = 28;
		else if(args[0].equalsIgnoreCase("firework")) entt = 29;
		else if(args[0].equalsIgnoreCase("boat")) entt = 30;
		else if(args[0].equalsIgnoreCase("minecart")) entt = 31;

		EntityType ent = null;
		Player player = (Player) sender;
		switch (entt){

		case 1: ent = EntityType.BAT;
		break;
		case 2: ent = EntityType.BLAZE;
		break;
		case 3: ent = EntityType.CAVE_SPIDER;
		break;
		case 4: ent = EntityType.CHICKEN;
		break;
		case 5: ent = EntityType.COW;
		break;
		case 6: ent = EntityType.CREEPER;
		break;
		case 7: ent = EntityType.ENDER_DRAGON;
		break;
		case 8: ent = EntityType.ENDERMAN;
		break;
		case 9: ent = EntityType.GHAST;
		break;
		case 10: ent = EntityType.GIANT;
		break;
		case 11: ent = EntityType.IRON_GOLEM;
		break;
		case 12: ent = EntityType.MAGMA_CUBE;
		break;
		case 13: ent = EntityType.MUSHROOM_COW;
		break;
		case 14: ent = EntityType.OCELOT;
		break;
		case 15: ent = EntityType.PIG;
		break;
		case 16: ent = EntityType.PIG_ZOMBIE;
		break;
		case 17: ent = EntityType.SHEEP;
		break;
		case 18: ent = EntityType.SILVERFISH;
		break;
		case 19: ent = EntityType.SKELETON;
		break;
		case 20: ent = EntityType.SLIME;
		break;
		case 21: ent = EntityType.SNOWMAN;
		break;
		case 22: ent = EntityType.SPIDER;
		break;
		case 23: ent = EntityType.SQUID;
		break;
		case 24: ent = EntityType.VILLAGER;
		break;
		case 25: ent = EntityType.WITCH;
		break;
		case 26: ent = EntityType.WITHER;
		break;
		case 27: ent = EntityType.WOLF;
		break;
		case 28: ent = EntityType.ZOMBIE;
		break;
		case 29: ent = EntityType.FIREWORK;
		break;
		case 30: ent = EntityType.BOAT;
		break;
		case 31: ent = EntityType.MINECART;
		}
		if(ent != null){ 
			Bukkit.getWorld(player.getWorld().getName()).spawnEntity(player.getLocation(), ent);
			if(args.length == 2){
				sender.sendMessage(ChatColor.BLUE + "Spawned "+ ChatColor.DARK_BLUE + args[0]);
			}
			else{
				sender.sendMessage(ChatColor.BLUE + "Spawned "+ ChatColor.DARK_BLUE + args[0] + " " + args[1]);
			}
		}
		else if(entt == 0){
			sender.sendMessage(ChatColor.RED + "Not a valid entity!");
		}
		else{
			sender.sendMessage(ChatColor.RED + "You need to add an entity!");
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	public void colourCMD(String[] args, CommandSender sender){
		if(args[0].equalsIgnoreCase("green")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.GREEN + chat);
		}

		else if(args[0].equalsIgnoreCase("blue")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.BLUE + chat);
		}

		else if(args[0].equalsIgnoreCase("red")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.RED + chat);
		}

		else if(args[0].equalsIgnoreCase("yellow")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.YELLOW + chat);
		}

		else if(args[0].equalsIgnoreCase("black")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.BLACK + chat);
		}

		else if(args[0].equalsIgnoreCase("gold")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.GOLD + chat);
		}

		else if(args[0].equalsIgnoreCase("gray")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.GRAY + chat);
		}

		else if(args[0].equalsIgnoreCase("random")){
			int i = 1;
			String chat = null;
			while(args[i] != null){
				i++;
				chat = chat + " " + args[i];
			}
			((Player) sender).chat(ChatColor.MAGIC + chat);
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public void openCMD(CommandSender sender, String[] args){
		if(sender.hasPermission("open.craft")){
			if(args[0].equalsIgnoreCase("craft")){
				InventoryHolder invHolder = (InventoryHolder) sender;
				Inventory craftinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 10, "Crafting"); 
				((Player) sender).openInventory(craftinv);
				sender.sendMessage("Opened Crafting grid!");
			}
		}
		else if(sender.hasPermission("open.anvil")){
			if(args[0].equalsIgnoreCase("anvil")){
				InventoryHolder invHolder = (InventoryHolder) sender;
				Inventory anvilinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 3, "Repairing");
				((Player) sender).openInventory(anvilinv);
				sender.sendMessage("Opened anvil!");
			}
		}
		else if(sender.hasPermission("open.enchant")){
			if(args[0].equalsIgnoreCase("enchant")){
				InventoryHolder invHolder = (InventoryHolder) sender;
				Inventory enchantinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 1, "Enchanting");
				((Player) sender).openInventory(enchantinv);
				sender.sendMessage("Opened enchantment table!");
			}
		}
		else if(sender.hasPermission("open.brew")){
			if(args[0].equalsIgnoreCase("brew")){
				InventoryHolder invHolder = (InventoryHolder) sender;
				Inventory brewinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 4, "Brewing");
				((Player) sender).openInventory(brewinv);
				sender.sendMessage("Opened Brewing stand!");
			}
		}
		else if(sender.hasPermission("open.smelt")){
			if(args[0].equalsIgnoreCase("smelt")){
				InventoryHolder invHolder = (InventoryHolder) sender;
				Inventory brewinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 3, "Furnace");
				((Player) sender).openInventory(brewinv);
				sender.sendMessage("Opened Furnace!");
			}
		}
		else if(sender.hasPermission("open.player")){
			if(args[0].equalsIgnoreCase("inv")){
				InventoryHolder invHolder = (InventoryHolder) Bukkit.getServer().getPlayer(args[1]);
				if(invHolder != null){
					Inventory brewinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 36, "Player");
					((Player) sender).openInventory(brewinv);
					sender.sendMessage("Opened " + args[1] + "'s Inventory!");
				}
				else{
					invHolder = (InventoryHolder) sender;
					Inventory brewinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 36, "Player");
					((Player) sender).openInventory(brewinv);
					sender.sendMessage("Opened " + sender + "'s Inventory!");
				}
			}
		}
		else if(sender.hasPermission("open.create")){
			if(args[0].equalsIgnoreCase("creative")){
				InventoryHolder invHolder = (InventoryHolder) sender;
				Inventory brewinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 9, "Creative");
				((Player) sender).openInventory(brewinv);
				sender.sendMessage("Opened Creative inventory!");
			}
		}
		else if(sender.hasPermission("open.ender")){
			if(args[0].equalsIgnoreCase("ender")){
				InventoryHolder invHolder = (InventoryHolder) Bukkit.getServer().getPlayer(args[1]);
				if(invHolder != null){
					Inventory brewinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 27, "Ender Chest");
					((Player) sender).openInventory(brewinv);
					sender.sendMessage("Opened " + args[1] + "'s Ender Chest!");
				}
				else{
					invHolder = (InventoryHolder) sender;
					Inventory brewinv = (Inventory) Bukkit.getServer().createInventory(invHolder, 27, "Ender Chest");
					((Player) sender).openInventory(brewinv);
					sender.sendMessage("Opened " + sender + "'s Ender Chest!");
				}
			}
		}

		else{
			sender.sendMessage("Use: /open... craft, brew, enchant, smelt or anvil");
			sender.sendMessage("Make sure not to close the GUI unless everything is out!");
		}
	}
	
}